package loadtests.examples.loadcoder;

import static com.loadcoder.statics.Statics.SECOND;
import static com.loadcoder.statics.Statics.duration;

import com.loadcoder.load.LoadUtility;
import com.loadcoder.load.chart.logic.RuntimeChart;
import com.loadcoder.load.scenario.ExecutionBuilder;
import com.loadcoder.load.scenario.Load;
import com.loadcoder.load.scenario.LoadBuilder;
import com.loadcoder.load.scenario.LoadScenario;
import com.loadcoder.result.Result;

/**
 * A Hello World example of a Loadcoder test
 */
public class HelloWorldLoadTest {

	public static void main(String[] args) {
		new HelloWorldLoadTest().simpleLoadTest();
	}
	
	LoadScenario loadScenario = new LoadScenario() {

		@Override
		public void loadScenario() {

			load("sleep", () -> {
				LoadUtility.sleep(20);
			}).perform();
		}

	};
	
	public void simpleLoadTest() {

		Load load = new LoadBuilder(loadScenario).amountOfThreads(10).rampup(10 * SECOND)
				.stopDecision(duration(20 * SECOND)).build();

		RuntimeChart runtimeChart = new RuntimeChart();

		Result result = new ExecutionBuilder(load).storeAndConsumeResultRuntime(runtimeChart).build().execute()
				.andWait().getReportedResultFromResultFile();

		result.summaryStandard().build().prettyPrint();
		
		runtimeChart.waitUntilClosed();

	}
}