package loadtests.cluster;

import static com.loadcoder.statics.LogbackLogging.getNewLogDir;
import static com.loadcoder.statics.LogbackLogging.setResultDestination;
import static com.loadcoder.statics.Statics.*;

import org.junit.Test;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.web.client.RestTemplate;

import com.loadcoder.load.LoadUtility;
import com.loadcoder.load.scenario.ExecutionBuilder;
import com.loadcoder.load.scenario.Load;
import com.loadcoder.load.scenario.LoadBuilder;
import com.loadcoder.load.scenario.LoadScenario;
import com.loadcoder.result.Result;
import com.loadcoder.utils.FileUtil;

public class ModuledLoadTest {

	RestTemplate defaultClient = new RestTemplate();
	
	@Test
	public void mainTest() {
		FileUtil.readFile(null);
		setResultDestination(getNewLogDir("target", "ModuledLoadTest"));

		LoadScenario ls = new LoadScenario() {

			@Override
			public void loadScenario() {
				load("sleeping", () -> runExample()).perform();
			}
		};
		Load l = new LoadBuilder(ls)
				.stopDecision(iterations(10))
				.build();
		Result result = new ExecutionBuilder(l).storeResultRuntime().build().execute()
				.andWait().getResultFromMemory();
		result.summaryStandard().build().prettyPrint();

	}
	
	
	private void runExample() {
		makeCall("http://localhost:7060/api/greeting?name=Loadcoder", defaultClient);
	}

	public ResponseEntity<String> makeCall(String url, RestTemplate t) {
		try {
			HttpEntity<String> req = new HttpEntity<>("");
			ResponseEntity<String> resp = t.exchange(url, HttpMethod.GET, req, String.class);
			return resp;
		}catch(Exception e) {
			throw new RuntimeException(e);
		}
	}

}
